Đến nội dung


Hình ảnh
- - - - -

Lisp convert arc, circle to polyline


  • Please log in to reply
2 replies to this topic

#1 tncd1504

tncd1504

    Chưa sử dụng CAD

  • Members
  • Pip
  • 1 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 01 July 2010 - 08:58 AM

Tui cần chia những đường cong như arc, circle thành những phần tử polyline để tạo wipeout và xuất wa những phần mềm tính toán bằng phương pháp phần tử hữu hạn. Tui lên google search đc cái lisp này thấy cũng ok nhưng mà nó chỉ có option chia theo segment length. Có cách nào chỉnh cái lisp này sao cho nó có thêm option chia theo "number of segments" không? :cheers:
(defun c:Segs (/ CLEN ENT I J PTS SEGNUM SS)
(vl-load-com); Lee Mac ~ 30.01.10

(setq *doc (cond (*doc) ((vla-get-ActiveDocument (vlax-get-acad-object))))
*sLen (cond (*sLen) (10.)))

(if (and (setq j -1 ss (ssget "_:L" '((0 . "ARC,CIRCLE,*POLYLINE,SPLINE,LINE,ELLIPSE"))))
(not (initget 6))
(setq *sLen (cond ((getdist (strcat "\nSpecify Segment Length <"
(rtos *sLen) "> : "))) (*sLen))))

(while (setq ent (ssname ss (setq j (1+ j))))
(vla-StartUndoMark *doc)

(setq cLen (vlax-curve-getDistAtParam ent
(vlax-curve-getEndParam ent)) segNum (fix (/ cLen *sLen)) i -1)

(or (zerop (rem cLen *sLen)) (setq segNum (1+ segNum)))

(repeat (1+ segNum)
(setq pts (cons (cond ((vlax-curve-getPointAtDist ent
(* (setq i (1+ i)) *sLen)))
((vlax-curve-getEndPoint ent))) pts)))

(entmake (append (list (cons 0 "LWPOLYLINE")
(cons 100 "AcDbEntity")
(cons 100 "AcDbPolyline")
(cons 90 (length pts))
(cons 70 0))
(mapcar (function (lambda (a) (cons 10 a))) pts)))

(entdel ent) (setq pts nil)
(vla-EndUndoMark *doc)))

(princ))

  • 0

#2 VUVUZELA

VUVUZELA

    biết lệnh chamfer

  • Members
  • PipPipPipPip
  • 210 Bài viết
Điểm đánh giá: 97 (tàm tạm)

Đã gửi 05 July 2010 - 03:42 PM

Tội cho thành viên này quá ! Lâu quá rồi không thấy cao thủ CADVIET nào giúp cả
Cũng như mình post bài "Tại sao không cập nhật dữ liệu mở rộng" mà cũng không thấy xuất hiện Cao Thủ

Vì vậy, sau thời gian nghiên cứu mình sẽ giúp cho bạn đoạn mã này nhé
Mong rằng bạn sẽ thích nó. Có gì pm cho mình

(defun c:WIPE (/)
(setvar "cmdecho" 0)
(command "_.undo" "be")
(setvar "regenmode" 1)
(setq osmode (getvar "osmode"))

(setq colo (getvar "clayer"))
(if (not (tblsearch "layer" "WIPE-TAM"))
(command "layer" "n" "WIPE-TAM" "color" "3" "WIPE-TAM" "s"
"WIPE-TAM" \n)
(command "layer" "s" "WIPE-TAM" \n)
)
(setvar "osmode" 0)
(command "ucs" "")

(setq abc (entsel "\nChon doi tuong :"))
(setq KC (getreal "\nNhap khoang cach de chia cung : "))

(COMMAND "MEASURE" ABC KC)
(setq ss (ssget "X"
'(
(-4 . " (0 . "POINT")
(8 . "WIPE-TAM")
(-4 . "AND>")
)
)
)
(command "pline")
(setq x 0)
(repeat (SSlength ss)
(setq ent (ssname ss x))
(setq ents (entget ent))
(setq pt (cdr (assoc 10 ents)))
(command pt)
(setq x (+ x 1))
)
(command "")

(COMMAND "erase" ss "")

(setvar "clayer" colo)
(setvar "osmode" osmode)
(command "_.undo" "e")
)

  • 0

Hệ thống Liên Kết, Thiết Kế Tự Động

ttps://www.facebook...etThietKeTuDong


#3 ht.thichvobien

ht.thichvobien

    biết zoom

  • Members
  • Pip
  • 13 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 19 April 2013 - 05:43 PM

ai có lisp chuyển circle thành pline k? cho e với


  • 0